/*! ********************************************
 * ProcessData.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox;

public class ProcessData
{
    // Instance -----
    public float sampleRate     = 44100.0f;
    public int audioChannels    = 2;
    public int blockSize        = 2048;  // Audio Process Block Size (BufferSize)
    public float[][] audioOut   = null;
    public MidiEvent midiEvents = null;  // MIDIEvent List (Single Linked [ SampleFrame Order ])
    public int offsetFrames     = 0;     // From the First Frame in the Audio Process Block.
    public int sampleFrames     = 0;     // Number of Frames to Process ( * Current Process() )
	
    public float audioLatency   = 0.0f;  // Audio Output Latency [mSec]

    // Method
    public void addToMidiEventList(MidiEvent event){ addToMidiEventList(event, false); }
    public void addToMidiEventList(MidiEvent event, boolean check)
    {
        MidiEvent _list = midiEvents.next;
		// check ---
		if (check)
		{
			_list = midiEvents.next;
			while (_list != null)
			{
				if (_list == event) return;
				_list = _list.next;
			}
		}
        // add to list ---
        _list = midiEvents;
        while (_list.next != null)
        {
            if (event.offsetFrames >= _list.next.offsetFrames) _list = _list.next;
            else break;
        }
        event.next = _list.next;
        _list.next = event;
    }
    // Constructor
    public ProcessData(){}
}