/*! ********************************************
 * SMFTrackEvent.java
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.smf;

public class SMFTrackEvent
{
	public SMFTrackEvent next = null;
	public int deltaTime  = 0;
	
	public int channel    = 0;
	public int type       = 0x80;
	public int value0     = 0;
	public int value1     = 0;
	
	public byte[] data    = null;
	public int dataSize   = 0;
// Constructor
	public void clear()
	{
		next = null;
		deltaTime = 0;
		
		channel = 0;
		type = 0x80;
		value0 = 0;
		value1 = 0;
		data = null;
		dataSize = 0;
	}
	public SMFTrackEvent(){}
	public SMFTrackEvent(int deltaTime, int type, int ch, int val0, int val1)
	{
		if (type == 0x90 && val1 == 0) type = 0x80; // [ noteOn & 0 velocity ] to [ noteOff ]
		this.deltaTime = deltaTime;
		this.type = type;
		this.channel = ch;
		this.value0 = val0;
		this.value1 = val1;
	}
}